//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class rsystem_hook_ipsForumsTopic extends _HOOK_CLASS_
{


	/**
	 * Should posting this increment the poster's post count?
	 *
	 * @param	\IPS\Node\Model|NULL	$container	Container
	 * @return	void
	 * @see		\IPS\Topic\Post::incrementPostCount()
	 */
	static public function incrementPostCount( \IPS\Node\Model $container=NULL )
	{
		try
		{
			try
			{
				$return = call_user_func_array( 'parent::incrementPostCount', func_get_args() );
		        
				/* Fast check */
				if( \IPS\Member::loggedIn()->dp3_rs_padded )
				{
					return true;
				}
		
				/* System is enabled and function too? */
				if( \IPS\Settings::i()->dp41_rsystem_enable && \IPS\Settings::i()->rsystem_points_integration_points_required )
				{
					/* Member is reffered by someone? */
					if( \IPS\Member::loggedIn()->dp3_rs_referred_by )
					{
						/* Points wasn't be added to the referrer account? */
						if( ! \IPS\Member::loggedIn()->dp3_rs_padded )
						{
							/* Member has exact or more points than set? */
							if( \IPS\Settings::i()->rsystem_points_integration_points_required <= \IPS\Member::loggedIn()->member_posts )
							{					
		                        /* Update referred member marker */
								\IPS\Member::loggedIn()->dp3_rs_padded = 1;
		                        \IPS\Member::loggedIn()->save();
		                        
								/* Add points to the referrer account */
		                        \IPS\rsystem\Settings::addPoints( \IPS\Member::loggedIn()->dp3_rs_referred_by );						
							}
						}
					}	
				}
		        
		        /* Play with min posts to add referred members to referred account */
		        if( \IPS\Settings::i()->dp41_rsystem_enable )
		        {
					if( \IPS\Member::loggedIn()->dp3_rs_referred_by )
					{
						if( ! \IPS\Member::loggedIn()->dp3_rs_incr )
						{
							if( \IPS\Settings::i()->dp41_rsystem_minimum_posts <= \IPS\Member::loggedIn()->member_posts )
							{					
								\IPS\Member::loggedIn()->dp3_rs_incr = 1;
		                        \IPS\Member::loggedIn()->save();
		                        
								\IPS\rsystem\Settings::playWithCheckKey();						
							}
						}
					}
		        }
		        
		        return $return;
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

}
